﻿Imports System.IO.Ports

Public Class FormMain

    Public Port_Com As String
    Public Port_Baudrate As String
    Public Port_Parity As String
    Public Poll_Interval As String
    Public Poll_TimeOut As String
    Public Tags_Name As New List(Of String)
    Public Tags_SlaveID As New List(Of String)
    Public Tags_Address As New List(Of String)
    Public Tags_RegType As New List(Of String)
    Public Tags_DataType As New List(Of String)
    Public Tags_Multiplier As New List(Of String)
    Public Tags_RoundDigit As New List(Of String)
    Public Tags_Value As New List(Of String)
    Public AutoActivate As String
    Public AutoFullScreen As String

    Dim WithEvents MBus As New Modbus_S.Modbus
    Dim SPort As New SerialPort()

    Dim Run_Connect As Boolean
    Dim Run_Polling As Boolean
    Dim Run_TagID As Integer
    Dim Run_TagAddr As Integer
    Dim Run_RegType As String
    Dim Run_DataType As String
    Dim Run_RegStart As Integer
    Dim Run_RegLength As Integer
    Dim Run_Waiting As Boolean
    Dim Run_Deactivate As Boolean

    Public Delegate Sub MsgReceive(ByVal b() As Byte)

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadListBoxes()

        '// Load Settings
        '/ cek file setting, create if not exist
        Dim fName As String = Application.StartupPath & "\Settings.txt"
        If FileIO.FileSystem.FileExists(fName) = False Then
            UpdateFileSetting()
        Else
            Try
                Dim fNum As Integer = FreeFile()
                FileOpen(fNum, fName, OpenMode.Input, OpenAccess.Read, OpenShare.Shared)
                Do Until EOF(fNum)
                    Dim sLine As String = LineInput(fNum)
                    Dim arLine() As String = Split(sLine, "=")
                    If arLine.Count > 1 Then
                        Dim sKey As String = arLine(0)
                        Dim sVal As String = arLine(1)
                        Select Case LCase(sKey)
                            Case "port_com"
                                Port_Com = sVal
                            Case "port_baudrate"
                                Port_Baudrate = sVal
                            Case "port_parity"
                                Port_Parity = sVal
                            Case "poll_interval"
                                Poll_Interval = sVal
                            Case "poll_timeout"
                                Poll_TimeOut = sVal
                            Case "tags_name"
                                Tags_Name = sVal.Split(";").ToList()
                            Case "tags_slaveid"
                                Tags_SlaveID = sVal.Split(";").ToList()
                            Case "tags_address"
                                Tags_Address = sVal.Split(";").ToList()
                            Case "tags_regtype"
                                Tags_RegType = sVal.Split(";").ToList()
                            Case "tags_datatype"
                                Tags_DataType = sVal.Split(";").ToList()
                            Case "tags_multiplier"
                                Tags_Multiplier = sVal.Split(";").ToList()
                            Case "tags_rounddigit"
                                Tags_RoundDigit = sVal.Split(";").ToList()
                            Case "autoactivate"
                                AutoActivate = sVal
                            Case "autofullscreen"
                                AutoFullScreen = sVal
                        End Select
                    End If
                Loop
                FileClose(fNum)
                If Tags_Name.Count > 0 Then
                    For i = 0 To Tags_Name.Count - 1
                        Tags_Value.Add("")
                    Next
                End If
            Catch ex As Exception
                '
            End Try

            '/ plot settings
            cboPorts.Text = Port_Com
            cboBaudrate.Text = Port_Baudrate
            cboParity.Text = Port_Parity
            txtPollInterval.Text = Poll_Interval
            txtPollTimeout.Text = Poll_TimeOut
            If Val(AutoActivate) = 1 Then AutoActivateRuntimeToolStripMenuItem.Checked = True
            If Val(AutoFullScreen) = 1 Then AutoFullScreenToolStripMenuItem.Checked = True

            dgTags.Rows.Clear()
            For i = 0 To Tags_Name.Count - 1
                dgTags.Rows.Add()
                dgTags.Rows(i).Cells(0).Value = Tags_Name(i)
                dgTags.Rows(i).Cells(1).Value = Tags_SlaveID(i)
                dgTags.Rows(i).Cells(2).Value = Tags_Address(i)
                dgTags.Rows(i).Cells(3).Value = Tags_RegType(i)
                dgTags.Rows(i).Cells(4).Value = Tags_DataType(i)
                dgTags.Rows(i).Cells(5).Value = Tags_Multiplier(i)
                dgTags.Rows(i).Cells(6).Value = Tags_RoundDigit(i)
            Next

            '/ auto activate
            If Val(AutoActivate) = 1 Then
                ActivateToolStripMenuItem_Click(Nothing, Nothing)
            End If

            '/ auto full screen
            If Val(AutoFullScreen) = 1 Then
                Me.WindowState = FormWindowState.Maximized
            End If

        End If

    End Sub

    Sub LoadListBoxes()
        '1) Available ports: 
        Dim ports() As String = SerialPort.GetPortNames()
        For Each port As String In ports
            cboPorts.Items.Add(port)
        Next
        'lstPorts.SelectedIndex = 0

        '2) Baudrates:
        Dim baudrates() As String = {"9600", "19200", "38400", "57600", "115200"}
        For Each baudrate As String In baudrates
            cboBaudrate.Items.Add(baudrate)
        Next
        'lstBaudrate.SelectedIndex = 0

        'Parity:
        Dim paritys() As String = {"None", "Odd", "Even", "Mark"}
        For Each parity As String In paritys
            cboParity.Items.Add(parity)
        Next
        'cboParity.SelectedIndex = 0

        '3) Datatype:
        Dim dataTypes() As String = {"Decimal", "Float", "Float Swap"}
        For Each dataType As String In dataTypes
            cboDataTypes.Items.Add(dataType)
        Next
        'cboDataTypes.SelectedIndex = 0

        '3) Reg type:
        Dim IOs() As String = {"Coil Output", "Digital Input", "Analog Input", "Holding Register"}
        For Each io As String In IOs
            cboRegTypes.Items.Add(io)
        Next
        'cboRegTypes.SelectedIndex = 3        
    End Sub

    Sub UpdateFileSetting()
        Try
            Dim fName As String = Application.StartupPath & "\Settings.txt"
            Dim fNum As Integer = FreeFile()
            FileOpen(fNum, fName, OpenMode.Output, OpenAccess.Write, OpenShare.Shared)
            Dim sPrint As String = ""
            sPrint = sPrint & "Port_Com=" & Port_Com & vbNewLine
            sPrint = sPrint & "Port_Baudrate=" & Port_Baudrate & vbNewLine
            sPrint = sPrint & "Port_Parity=" & Port_Parity & vbNewLine
            sPrint = sPrint & "Poll_Interval=" & Poll_Interval & vbNewLine
            sPrint = sPrint & "Poll_TimeOut=" & Poll_TimeOut & vbNewLine
            If Tags_Name.Count > 0 Then
                sPrint = sPrint & "Tags_Name=" & String.Join(";", Tags_Name.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_SlaveID=" & String.Join(";", Tags_SlaveID.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_Address=" & String.Join(";", Tags_Address.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_RegType=" & String.Join(";", Tags_RegType.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_DataType=" & String.Join(";", Tags_DataType.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_Multiplier=" & String.Join(";", Tags_Multiplier.ToArray()) & vbNewLine
                sPrint = sPrint & "Tags_RoundDigit=" & String.Join(";", Tags_RoundDigit.ToArray()) & vbNewLine
            End If
            sPrint = sPrint & "AutoActivate=" & AutoActivate & vbNewLine
            sPrint = sPrint & "AutoFullScreen=" & AutoFullScreen & vbNewLine
            Print(fNum, sPrint)
            FileClose(fNum)
        Catch ex As Exception
            '
        End Try
    End Sub

    Private Sub btnEditPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditPort.Click
        cboPorts.Enabled = True
        cboBaudrate.Enabled = True
        cboParity.Enabled = True
        txtPollInterval.ReadOnly = False
        txtPollTimeout.ReadOnly = False
        btnEditPort.Visible = False
        btnOKEditPort.Visible = True
        btnCancelEditPort.Visible = True
    End Sub

    Private Sub btnOKEditPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOKEditPort.Click
        Port_Com = cboPorts.Text
        Port_Baudrate = cboBaudrate.Text
        Port_Parity = cboParity.Text
        Poll_Interval = Trim(txtPollInterval.Text)
        Poll_TimeOut = Trim(txtPollTimeout.Text)
        UpdateFileSetting()
        btnCancelEditPort_Click(Nothing, Nothing)
    End Sub

    Private Sub btnCancelEditPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancelEditPort.Click
        cboPorts.Text = Port_Com
        cboBaudrate.Text = Port_Baudrate
        cboParity.Text = Port_Parity
        txtPollInterval.Text = Poll_Interval
        txtPollTimeout.Text = Poll_TimeOut
        cboPorts.Enabled = False
        cboBaudrate.Enabled = False
        cboParity.Enabled = False
        txtPollInterval.ReadOnly = True
        txtPollTimeout.ReadOnly = True
        btnEditPort.Visible = True
        btnOKEditPort.Visible = False
        btnCancelEditPort.Visible = False
    End Sub

    Private Sub btnAddTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTag.Click
        dgTags.Enabled = False
        grpEditTag.Text = "Add Tag"
        txtTagname.Text = ""
        txtSlaveID.Text = ""
        txtAddress.Text = ""
        cboRegTypes.Text = ""
        cboDataTypes.Text = ""
        txtMultiplier.Text = ""
        txtRoundDigit.Text = ""
        lblMultiRound.Text = "Multiplier :"
        txtMultiplier.Visible = True
        txtRoundDigit.Visible = False
        grpEditTag.Visible = True
        panelAddTag.Visible = False
    End Sub

    Private Sub btnOKEditTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOKEditTag.Click
        Dim sName As String = Trim(txtTagname.Text)
        If grpEditTag.Text = "Add Tag" Then
            '/cek duplicate tag name
            If Tags_Name.Contains(sName, StringComparer.OrdinalIgnoreCase) Then
                MsgBox("Duplicate Tag Name!")
            Else
                Tags_Name.Add(Trim(txtTagname.Text))
                Tags_SlaveID.Add(Trim(txtSlaveID.Text))
                Tags_Address.Add(Trim(txtAddress.Text))
                Tags_RegType.Add(Trim(cboRegTypes.Text))
                Tags_DataType.Add(Trim(cboDataTypes.Text))
                Tags_Multiplier.Add(Trim(txtMultiplier.Text))
                Tags_RoundDigit.Add(Trim(txtRoundDigit.Text))
                Tags_Value.Add("")
                dgTags.Rows.Add()
                Dim i As Integer = Tags_Name.Count - 1
                dgTags.Rows(i).Cells(0).Value = Tags_Name(i)
                dgTags.Rows(i).Cells(1).Value = Tags_SlaveID(i)
                dgTags.Rows(i).Cells(2).Value = Tags_Address(i)
                dgTags.Rows(i).Cells(3).Value = Tags_RegType(i)
                dgTags.Rows(i).Cells(4).Value = Tags_DataType(i)
                dgTags.Rows(i).Cells(5).Value = Tags_Multiplier(i)
                dgTags.Rows(i).Cells(6).Value = Tags_RoundDigit(i)
                UpdateFileSetting()
                btnCancelEditTag_Click(Nothing, Nothing)
            End If

        ElseIf grpEditTag.Text = "Edit Tag" Then
            Dim i As Integer = Val(lblRowId.Text)
            Dim bDuplicate As Boolean = False
            Dim oldName As String = Tags_Name(i)
            If oldName <> sName Then
                '/cek duplicate tag name
                If Tags_Name.Contains(sName, StringComparer.OrdinalIgnoreCase) Then
                    bDuplicate = True
                End If
            End If
            If bDuplicate = True Then
                MsgBox("Duplicate Tag Name!")
            Else
                Tags_Name(i) = Trim(txtTagname.Text)
                Tags_SlaveID(i) = Trim(txtSlaveID.Text)
                Tags_Address(i) = Trim(txtAddress.Text)
                Tags_RegType(i) = Trim(cboRegTypes.Text)
                Tags_DataType(i) = Trim(cboDataTypes.Text)
                Tags_Multiplier(i) = Trim(txtMultiplier.Text)
                Tags_RoundDigit(i) = Trim(txtRoundDigit.Text)
                dgTags.Rows(i).Cells(0).Value = Tags_Name(i)
                dgTags.Rows(i).Cells(1).Value = Tags_SlaveID(i)
                dgTags.Rows(i).Cells(2).Value = Tags_Address(i)
                dgTags.Rows(i).Cells(3).Value = Tags_RegType(i)
                dgTags.Rows(i).Cells(4).Value = Tags_DataType(i)
                dgTags.Rows(i).Cells(5).Value = Tags_Multiplier(i)
                dgTags.Rows(i).Cells(6).Value = Tags_RoundDigit(i)
                UpdateFileSetting()
                btnCancelEditTag_Click(Nothing, Nothing)
            End If
        End If
    End Sub

    Private Sub btnCancelEditTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancelEditTag.Click
        grpEditTag.Visible = False
        panelAddTag.Visible = True
        dgTags.Enabled = True
    End Sub

    Private Sub dgTags_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgTags.SelectionChanged
        If dgTags.SelectedCells.Count > 0 Then
            Dim idx As Integer = dgTags.SelectedCells(0).RowIndex
            If (dgTags.Rows(idx).Cells(0).Value = "") Then
                btnEditTag.Visible = False
                btnDeleteTag.Visible = False
                lblRowId.Text = "-1"
            Else
                btnEditTag.Visible = True
                btnDeleteTag.Visible = True
                lblRowId.Text = idx
            End If
        Else
            btnEditTag.Visible = False
            btnDeleteTag.Visible = False
            lblRowId.Text = "-1"
        End If
    End Sub

    Private Sub btnEditTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTag.Click
        Dim i As Integer = Val(lblRowId.Text)
        If i > -1 Then
            dgTags.Enabled = False
            grpEditTag.Text = "Edit Tag"
            txtTagname.Text = Tags_Name(i)
            txtSlaveID.Text = Tags_SlaveID(i)
            txtAddress.Text = Tags_Address(i)
            cboRegTypes.Text = Tags_RegType(i)
            cboDataTypes.Text = Tags_DataType(i)
            txtMultiplier.Text = Tags_Multiplier(i)
            txtRoundDigit.Text = Tags_RoundDigit(i)
            Dim sType As String = cboDataTypes.Text
            If UCase(sType) = "DECIMAL" Then
                lblMultiRound.Text = "Multiplier :"
                txtMultiplier.Visible = True
                txtRoundDigit.Visible = False
            ElseIf UCase(sType) = "FLOAT" Or UCase(sType) = "FLOAT SWAP" Then
                lblMultiRound.Text = "Round Digit :"
                txtMultiplier.Visible = False
                txtRoundDigit.Visible = True
            End If
            grpEditTag.Visible = True
            panelAddTag.Visible = False
        End If
    End Sub

    Private Sub btnDeleteTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteTag.Click
        Dim i As Integer = Val(lblRowId.Text)
        If i > -1 Then
            If MsgBox("Are you sure to Delete ?", vbOKCancel, "Delete Tag") = vbOK Then
                Tags_Name.RemoveAt(i)
                Tags_SlaveID.RemoveAt(i)
                Tags_Address.RemoveAt(i)
                Tags_RegType.RemoveAt(i)
                Tags_DataType.RemoveAt(i)
                Tags_Multiplier.RemoveAt(i)
                Tags_RoundDigit.RemoveAt(i)
                Tags_Value.RemoveAt(i)
                dgTags.Rows.RemoveAt(i)
                UpdateFileSetting()
            End If
        End If
    End Sub

    Private Sub ActivateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActivateToolStripMenuItem.Click
        'Open COM port using provided settings:
        Dim iParity As Integer
        Select Case UCase(Port_Parity)
            Case "NONE"
                iParity = Parity.None
            Case "EVEN"
                iParity = Parity.Even
            Case "ODD"
                iParity = Parity.Odd
            Case "MARK"
                iParity = Parity.Mark
            Case "SPACE"
                iParity = Parity.Space
        End Select
        If (MBus.Connect(Port_Com, Convert.ToInt32(Port_Baudrate), 8, iParity, StopBits.One)) Then
            ActivateToolStripMenuItem.Enabled = False
            DeactivateToolStripMenuItem.Enabled = True
            Run_Connect = True
            statConnection.Text = "Connection: OK"
            statRuntime.Text = "Runtime: Active"
            Run_TagID = -1
            TimerPoll.Interval = Poll_Interval * 1000
            TimerPoll.Start()
            Run_Polling = True
            TimerPlot.Interval = Poll_Interval * 1000
            TimerPlot.Start()
        End If
    End Sub

    Private Sub DeactivateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeactivateToolStripMenuItem.Click
        Run_Deactivate = True
        TimerDeactivate.Start()
    End Sub

    Sub DeactivteRuntime()
        Run_Polling = False
        MBus.Close()
        Run_Connect = False
        Run_Deactivate = False
        ActivateToolStripMenuItem.Enabled = True
        DeactivateToolStripMenuItem.Enabled = False
        statConnection.Text = "Connection: -"
        statRuntime.Text = "Runtime: -"
        statPolling.Text = "Polling: -"
    End Sub

    Private Sub TimerPoll_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerPoll.Tick
        TimerPoll.Stop()
        TimerTimeout.Interval = Val(Poll_TimeOut) * 1000
        TimerTimeout.Start()
        'Read registers and display data in desired format:
        Try
            If Run_TagID < Tags_Name.Count - 1 Then
                Run_TagID += 1
                Run_RegType = Tags_RegType(Run_TagID)
                Run_DataType = Tags_DataType(Run_TagID)
                Dim lAddr As Long = Val(Tags_Address(Run_TagID))
                Dim iSlaveID As Integer = Val(Tags_SlaveID(Run_TagID))
                Dim iRegLength = 1
                If UCase(Run_DataType) = "FLOAT" Or UCase(Run_DataType) = "FLOAT SWAP" Then
                    iRegLength = 2
                End If
                Run_RegLength = iRegLength
                Dim iRegStart
                Run_Waiting = True
                Select Case UCase(Run_RegType)
                    Case "COIL OUTPUT"
                        iRegStart = lAddr - 1
                        Run_RegStart = iRegStart
                        Do Until (MBus.SendFc1(iSlaveID, iRegStart, iRegLength) Or Run_Connect = False)
                            Application.DoEvents()
                        Loop
                    Case "DIGITAL INPUT"
                        iRegStart = lAddr - 10001
                        Run_RegStart = iRegStart
                        Do Until (MBus.SendFc2(iSlaveID, iRegStart, iRegLength) Or Run_Connect = False)
                            Application.DoEvents()
                        Loop
                    Case "ANALOG INPUT"
                        iRegStart = lAddr - 30001
                        Run_RegStart = iRegStart
                        Do Until (MBus.SendFc4(iSlaveID, iRegStart, iRegLength) Or Run_Connect = False)
                            Application.DoEvents()
                        Loop
                    Case "HOLDING REGISTER"
                        iRegStart = lAddr - 40001
                        Run_RegStart = iRegStart
                        Do Until (MBus.SendFc3(iSlaveID, iRegStart, iRegLength) Or Run_Connect = False)
                            Application.DoEvents()
                        Loop
                End Select
            Else
                Run_TagID = -1
                If Run_Polling = True Then
                    TimerPoll.Interval = Poll_Interval * 1000
                    TimerPoll.Start()
                End If
            End If
        Catch err As Exception
            statPolling.Text = "Polling: Error!"
        End Try
    End Sub

    Public Sub MsgReceived(ByVal b() As Byte)
        TimerTimeout.Stop()
        Select Case UCase(Run_RegType)
            Case "COIL OUTPUT", "DIGITAL INPUT"
                Dim nW As Integer = Run_RegLength \ 8
                If (Run_RegLength Mod 8) > 0 Then
                    nW = nW + 1
                End If
                For i = 3 To (nW + 2)
                    Dim arrBits As BitArray = New BitArray(System.BitConverter.GetBytes(b(i)))
                    'For j = 0 To 7
                    '    Dim _val = (Math.Abs(Val(arrBits(j))))
                    '    Tags_Value(Run_TagID) = _val '* Tags_Multiplier(Run_TagID)
                    '    dgTags.Rows(Run_TagID).Cells(7).Value = Tags_Value(Run_TagID)
                    'Next
                    Dim _val = (Math.Abs(Val(arrBits(0))))
                    Tags_Value(Run_TagID) = _val '* Tags_Multiplier(Run_TagID)
                    dgTags.Rows(Run_TagID).Cells(7).Value = Tags_Value(Run_TagID)
                Next

            Case "ANALOG INPUT", "HOLDING REGISTER"
                If UCase(Run_DataType) = "DECIMAL" Then
                    For i = 3 To (b(2) + 2)
                        Dim _bytes(1) As Byte
                        _bytes(0) = b(i + 1)
                        _bytes(1) = b(i)
                        Dim _val = BitConverter.ToInt16(_bytes, 0)
                        Tags_Value(Run_TagID) = (_val) * Val(Tags_Multiplier(Run_TagID))
                        dgTags.Rows(Run_TagID).Cells(7).Value = Tags_Value(Run_TagID)
                        i += 1
                    Next
                ElseIf UCase(Run_DataType) = "FLOAT" Then
                    For i = 3 To (b(2) + 2)
                        Dim _bytes(3) As Byte
                        _bytes(0) = b(i + 1)
                        _bytes(1) = b(i)
                        _bytes(2) = b(i + 3)
                        _bytes(3) = b(i + 2)
                        Dim _val = BitConverter.ToSingle(_bytes, 0)
                        Dim iRound As Integer = Val(Tags_RoundDigit(Run_TagID))
                        _val = Math.Round(_val, iRound)
                        Tags_Value(Run_TagID) = (_val) '* Val(Tags_Multiplier(Run_TagID))
                        dgTags.Rows(Run_TagID).Cells(7).Value = Tags_Value(Run_TagID)
                        i += 3
                    Next
                ElseIf UCase(Run_DataType) = "FLOAT SWAP" Then
                    For i = 3 To (b(2) + 2)
                        Dim _bytes(3) As Byte
                        _bytes(0) = b(i + 3)
                        _bytes(1) = b(i + 2)
                        _bytes(2) = b(i + 1)
                        _bytes(3) = b(i)
                        Dim _val = BitConverter.ToSingle(_bytes, 0)
                        Dim iRound As Integer = Val(Tags_RoundDigit(Run_TagID))
                        _val = Math.Round(_val, iRound)
                        Tags_Value(Run_TagID) = (_val) '* Val(Tags_Multiplier(Run_TagID))
                        dgTags.Rows(Run_TagID).Cells(7).Value = Tags_Value(Run_TagID)
                        i += 3
                    Next
                End If
        End Select
        Run_Waiting = False
        statPolling.Text = "Polling: OK"
        If Run_Deactivate = False Then
            If Run_Polling = True Then
                TimerPoll.Interval = 1
                TimerPoll.Start()
            End If
        Else
            Run_Deactivate = False
        End If
    End Sub
    Private Sub MBus_MessageRecived(ByVal b() As Byte) Handles MBus.MessageRecived
        Invoke(New MsgReceive(AddressOf MsgReceived), b)
    End Sub

    Private Sub TimerPlot_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerPlot.Tick
        TimerPlot.Stop()
        Dim ctrl As Control
        For Each ctrl In pageScreen.Controls
            Try
                Dim sTag As String = ctrl.Tag
                If (sTag.ToLower().Contains("visible=")) Then
                    sTag = sTag.ToLower().Replace("visible=", "")
                    For i = 0 To Tags_Name.Count - 1
                        If sTag = Tags_Name(i) Then
                            If Val(Tags_Value(i)) = 1 Then
                                ctrl.Visible = True
                            Else
                                ctrl.Visible = False
                            End If
                            Exit For
                        End If
                    Next
                Else
                    For i = 0 To Tags_Name.Count - 1
                        If sTag = Tags_Name(i) Then
                            ctrl.Text = Tags_Value(i)
                            Exit For
                        End If
                    Next
                End If
            Catch ex As Exception
                '
            End Try
        Next
        If Run_Polling = True Then
            TimerPlot.Start()
        End If
    End Sub

    Private Sub cboDataTypes_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDataTypes.SelectedIndexChanged
        Dim sType As String = cboDataTypes.Text
        If UCase(sType) = "DECIMAL" Then
            lblMultiRound.Text = "Multiplier :"
            txtMultiplier.Visible = True
            txtRoundDigit.Visible = False
        ElseIf UCase(sType) = "FLOAT" Or UCase(sType) = "FLOAT SWAP" Then
            lblMultiRound.Text = "Round Digit :"
            txtMultiplier.Visible = False
            txtRoundDigit.Visible = True
        End If
    End Sub

    Private Sub ScreenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ScreenToolStripMenuItem.Click
        TabControl1.SelectedIndex = 0
    End Sub

    Private Sub TagManagementToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TagManagementToolStripMenuItem.Click
        TabControl1.SelectedIndex = 1
    End Sub

    Private Sub AutoActivateRuntimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoActivateRuntimeToolStripMenuItem.Click
        If AutoActivateRuntimeToolStripMenuItem.Checked = True Then
            AutoActivateRuntimeToolStripMenuItem.Checked = False
            AutoActivate = "0"
        Else
            AutoActivateRuntimeToolStripMenuItem.Checked = True
            AutoActivate = "1"
        End If
        UpdateFileSetting()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        Dim sInfo As String = ""
        sInfo = sInfo & "Modbus RTU Client Advance" & vbNewLine & vbNewLine
        sInfo = sInfo & "Version " & Application.ProductVersion & vbNewLine & vbNewLine
        sInfo = sInfo & "created by HadiSCADA" & vbNewLine
        sInfo = sInfo & "email: hadiScada@gmail.com" & vbNewLine
        sInfo = sInfo & "blog: hadiscada.blogspot.com" & vbNewLine & vbNewLine
        sInfo = sInfo & "Thank you..." & vbNewLine
        MsgBox(sInfo, , "About")
    End Sub

    Private Sub TimerTimeout_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerTimeout.Tick
        TimerTimeout.Stop()
        statPolling.Text = "Polling: Timeout!"
        Run_Waiting = False
        If Run_Deactivate = False Then
            If Run_Polling = True Then
                TimerPoll.Interval = 1
                TimerPoll.Start()
            End If
        Else
            Run_Deactivate = False
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        If Run_Connect = True Then
            DeactivateToolStripMenuItem_Click(Nothing, Nothing)
        End If
        End
    End Sub

    Private Sub TimerDeactivate_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerDeactivate.Tick
        TimerDeactivate.Stop()
        If Run_Deactivate = False Then
            DeactivteRuntime()
        Else
            TimerDeactivate.Start()
        End If
    End Sub

    Private Sub AutoFullScreenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoFullScreenToolStripMenuItem.Click
        If AutoFullScreenToolStripMenuItem.Checked = True Then
            AutoFullScreenToolStripMenuItem.Checked = False
            AutoFullScreen = "0"
        Else
            AutoFullScreenToolStripMenuItem.Checked = True
            AutoFullScreen = "1"
        End If
        UpdateFileSetting()
    End Sub
End Class